Index: /palm/trunk/SOURCE/land_surface_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 3273)
+++ /palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 3274)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Modularization of all bulk cloud physics code components
+! 
+! 3271 2018-09-24 08:20:34Z suehring
 ! Several bugfixes:
 ! - Initialization of pt_surface array with soil temperature in the uppermost
@@ -474,17 +477,17 @@
  
     USE arrays_3d,                                                             &
-        ONLY:  hyp, pt, prr, q, q_p, ql, vpt, u, v, w
+        ONLY:  hyp, pt, prr, q, q_p, ql, vpt, u, v, w, hyrho, exner, d_exner
+
+    USE basic_constants_and_equations_mod,                                     &
+        ONLY:  c_p, g, lv_d_cp, l_v, magnus, rho_l, r_d, r_v
 
     USE calc_mean_profile_mod,                                                 &
         ONLY:  calc_mean_profile
 
-    USE cloud_parameters,                                                      &
-        ONLY:  cp, hyrho, l_d_cp, l_d_r, l_v, pt_d_t, rho_l, r_d, r_v
-
     USE control_parameters,                                                    &
-        ONLY:  cloud_droplets, cloud_physics, coupling_start_time, dt_3d,      &
+        ONLY:  cloud_droplets, coupling_start_time, dt_3d,      &
                end_time, humidity, intermediate_timestep_count,                &
                initializing_actions, intermediate_timestep_count_max,          &
-               land_surface, max_masks, precipitation, pt_surface,             &
+               land_surface, max_masks, pt_surface,             &
                rho_surface, spinup, spinup_pt_mean, spinup_time,               &
                surface_pressure, timestep_scheme, tsc,                         &
@@ -493,4 +496,7 @@
     USE indices,                                                               &
         ONLY:  nbgp, nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb
+
+    USE bulk_cloud_model_mod,                                                  &
+        ONLY: bulk_cloud_model, precipitation
 
     USE netcdf_data_input_mod,                                                 &
@@ -584,5 +590,4 @@
                 deep_soil_temperature =  9999999.9_wp,  & !< Deep soil temperature (bottom boundary condition)
                 drho_l_lv,                              & !< (rho_l * l_v)**-1
-                exn,                                    & !< value of the Exner function
                 field_capacity = 9999999.9_wp,          & !< NAMELIST m_fc
                 f_shortwave_incoming = 9999999.9_wp,    & !< NAMELIST f_sw_in
@@ -604,5 +609,4 @@
                 rho_cp,                                 & !< rho_surface * cp
                 rho_lv,                                 & !< rho_ocean * l_v
-                rd_d_rv,                                & !< r_d / r_v
                 saturation_moisture = 9999999.9_wp,     & !< NAMELIST m_sat
                 skip_time_do_lsm = 0.0_wp,              & !< LSM is not called before this time
@@ -1734,7 +1738,4 @@
  SUBROUTINE lsm_energy_balance( horizontal, l )
 
-    USE diagnostic_quantities_mod,                                             &
-        ONLY:  magnus 
-
     USE pegrid
 
@@ -1816,8 +1817,4 @@
     j_off = surf%joff
     i_off = surf%ioff
-    
-!
-!-- Calculate the exner function for the current time step
-    exn = ( surface_pressure / 1000.0_wp )**0.286_wp
 
     DO  m = 1, surf%ns
@@ -1889,9 +1886,9 @@
 !--    time step is used here. Note that this formulation is the
 !--    equivalent to the ECMWF formulation using drag coefficients
-!        IF ( cloud_physics )  THEN
-!           pt1 = pt(k,j,i) + l_d_cp * pt_d_t(k) * ql(k,j,i)
+!        IF ( bulk_cloud_model )  THEN
+!           pt1 = pt(k,j,i) + lv_d_cp * d_exner(k) * ql(k,j,i)
 !           qv1 = q(k,j,i) - ql(k,j,i)
 !        ELSEIF ( cloud_droplets ) THEN
-!           pt1 = pt(k,j,i) + l_d_cp * pt_d_t(k) * ql(k,j,i)
+!           pt1 = pt(k,j,i) + lv_d_cp * d_exner(k) * ql(k,j,i)
 !           qv1 = q(k,j,i) 
 !        ELSE
@@ -2097,5 +2094,5 @@
 !--       Denominator of the prognostic equation
           coef_2 = surf%rad_lw_out_change_0(m) + f_qsws * dq_s_dt              &
-                   + lambda_surface + f_shf / exn
+                   + lambda_surface + f_shf / exner(nzb)
        ELSE
 !
@@ -2107,5 +2104,5 @@
 !
 !--       Denominator of the prognostic equation
-          coef_2 = surf%rad_lw_out_change_0(m) + lambda_surface + f_shf / exn
+          coef_2 = surf%rad_lw_out_change_0(m) + lambda_surface + f_shf / exner(nzb)
 
        ENDIF
@@ -2160,6 +2157,6 @@
 
 
-!        pt(k+k_off,j+j_off,i+i_off) = surf_t_surface_p%var_1d(m) / exn  !is actually no air temperature
-       surf%pt_surface(m)          = surf_t_surface_p%var_1d(m) / exn
+!        pt(k+k_off,j+j_off,i+i_off) = surf_t_surface_p%var_1d(m) / exner(nzb)  !is actually no air temperature
+       surf%pt_surface(m)          = surf_t_surface_p%var_1d(m) / exner(nzb)
 
 !
@@ -2177,5 +2174,5 @@
                                              - surf_t_soil%var_2d(nzb_soil,m) )
 
-       surf%shf(m) = - f_shf * ( surf%pt1(m) - surf%pt_surface(m) ) / cp
+       surf%shf(m) = - f_shf * ( surf%pt1(m) - surf%pt_surface(m) ) / c_p
 
        IF ( humidity )  THEN
@@ -2330,9 +2327,9 @@
     SUBROUTINE calc_q_surface
 
-       USE diagnostic_quantities_mod
-
        IMPLICIT NONE
 
-       REAL(wp) :: resistance    !< aerodynamic and soil resistance term
+       REAL(wp) ::  e_s           !< saturation water vapor pressure
+       REAL(wp) ::  q_s           !< saturation mixing ratio
+       REAL(wp) ::  resistance    !< aerodynamic and soil resistance term
 
        DO  m = 1, surf%ns
@@ -2353,5 +2350,5 @@
 !
 !--       Calculate mixing ratio at surface
-          IF ( cloud_physics )  THEN
+          IF ( bulk_cloud_model )  THEN
              q(k+k_off,j+j_off,i+i_off) = resistance * q_s +                   &
                                         ( 1.0_wp - resistance ) *              &
@@ -2471,5 +2468,5 @@
 !------------------------------------------------------------------------------!
     SUBROUTINE lsm_init
-    
+
        USE control_parameters,                                                 &
            ONLY:  message_string
@@ -2501,19 +2498,14 @@
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  bound, bound_root_fr  !< temporary arrays for storing index bounds
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  pr_soil_init !< temporary array used for averaging soil profiles
-
-!
-!--    Calculate Exner function
-       exn = ( surface_pressure / 1000.0_wp )**0.286_wp
 !
 !--    If no cloud physics is used, rho_surface has not been calculated before
-       IF (  .NOT.  cloud_physics  .AND.  .NOT.  cloud_droplets )  THEN
+       IF (  .NOT.  bulk_cloud_model  .AND.  .NOT.  cloud_droplets )  THEN
           CALL calc_mean_profile( pt, 4 )
-          rho_surface = surface_pressure * 100.0_wp / ( r_d * hom(topo_min_level+1,1,4,0) * exn )
+          rho_surface = hyp(nzb) / ( r_d * hom(topo_min_level+1,1,4,0) * exner(nzb) )
        ENDIF
 
 !
 !--    Calculate frequently used parameters
-       rho_cp    = cp * rho_surface
-       rd_d_rv   = r_d / r_v
+       rho_cp    = c_p * rho_surface
        rho_lv    = rho_surface * l_v
        drho_l_lv = 1.0_wp / (rho_l * l_v)
@@ -4451,8 +4443,8 @@
 !--          uppermost layer
              t_surface_h%var_1d(m)    = t_soil_h%var_2d(nzb_soil,m)
-             surf_lsm_h%pt_surface(m) = t_soil_h%var_2d(nzb_soil,m) / exn
+             surf_lsm_h%pt_surface(m) = t_soil_h%var_2d(nzb_soil,m) / exner(nzb)
              
-             IF ( cloud_physics  .OR. cloud_droplets ) THEN
-                surf_lsm_h%pt1(m) = pt(k,j,i) + l_d_cp * pt_d_t(k) * ql(k,j,i)
+             IF ( bulk_cloud_model  .OR. cloud_droplets ) THEN
+                surf_lsm_h%pt1(m) = pt(k,j,i) + lv_d_cp * d_exner(k) * ql(k,j,i)
              ELSE
                 surf_lsm_h%pt1(m) = pt(k,j,i)
@@ -4480,8 +4472,8 @@
 !--             uppermost layer
                 t_surface_v(l)%var_1d(m)      = t_soil_v(l)%var_2d(nzb_soil,m)
-                surf_lsm_v(l)%pt_surface(m)   = t_soil_v(l)%var_2d(nzb_soil,m) / exn
-
-                IF ( cloud_physics  .OR. cloud_droplets ) THEN
-                   surf_lsm_v(l)%pt1(m) = pt(k,j,i) + l_d_cp * pt_d_t(k) * ql(k,j,i)
+                surf_lsm_v(l)%pt_surface(m)   = t_soil_v(l)%var_2d(nzb_soil,m) / exner(nzb)
+
+                IF ( bulk_cloud_model  .OR. cloud_droplets ) THEN
+                   surf_lsm_v(l)%pt1(m) = pt(k,j,i) + lv_d_cp * d_exner(k) * ql(k,j,i)
                 ELSE
                    surf_lsm_v(l)%pt1(m) = pt(k,j,i)
@@ -7078,5 +7070,5 @@
 
        USE control_parameters,                                                 &
-           ONLY: g, message_string, molecular_viscosity
+           ONLY: message_string, molecular_viscosity
 
        IMPLICIT NONE
Index: /palm/trunk/SOURCE/lpm_advec.f90
===================================================================
--- /palm/trunk/SOURCE/lpm_advec.f90	(revision 3273)
+++ /palm/trunk/SOURCE/lpm_advec.f90	(revision 3274)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Modularization of all bulk cloud physics code components
+! 
+! 3241 2018-09-12 15:02:00Z raasch
 ! unused variables removed
 ! 
@@ -173,4 +176,7 @@
         ONLY:  de_dx, de_dy, de_dz, diss, dzw, e, km, u, v, w, zu, zw
 
+    USE basic_constants_and_equations_mod,                                     &
+        ONLY:  g, kappa
+
     USE cpulog
 
@@ -179,5 +185,5 @@
     USE control_parameters,                                                    &
         ONLY:  cloud_droplets, constant_flux_layer, dt_3d, dt_3d_reached_l,    &
-               dz, g, kappa, topography, u_gtrans, v_gtrans
+               dz, topography, u_gtrans, v_gtrans
 
     USE grid_variables,                                                        &
Index: /palm/trunk/SOURCE/lpm_calc_liquid_water_content.f90
===================================================================
--- /palm/trunk/SOURCE/lpm_calc_liquid_water_content.f90	(revision 3273)
+++ /palm/trunk/SOURCE/lpm_calc_liquid_water_content.f90	(revision 3274)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Modularization of all bulk cloud physics code components
+! 
+! 3241 2018-09-12 15:02:00Z raasch
 ! unused variables removed
 ! 
@@ -75,9 +78,6 @@
         ONLY:  dzw, ql, ql_v, ql_vp
 
-    USE cloud_parameters,                                                      &
-        ONLY:  rho_l
-
-    USE constants,                                                             &
-        ONLY:  pi
+    USE basic_constants_and_equations_mod,                                     &
+        ONLY:  pi, rho_l
 
     USE control_parameters,                                                    &
Index: /palm/trunk/SOURCE/lpm_collision_kernels.f90
===================================================================
--- /palm/trunk/SOURCE/lpm_collision_kernels.f90	(revision 3273)
+++ /palm/trunk/SOURCE/lpm_collision_kernels.f90	(revision 3274)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Modularization of all bulk cloud physics code components
+! 
+! 2718 2018-01-02 08:49:38Z maronga
 ! Corrected "Former revisions" section
 ! 
@@ -135,6 +138,6 @@
  
 
-    USE constants,                                                             &
-        ONLY:  pi
+    USE basic_constants_and_equations_mod,                                     &
+        ONLY:  g, pi
         
     USE kinds
@@ -404,5 +407,5 @@
 
        USE control_parameters,                                                 &
-           ONLY:  g, molecular_viscosity
+           ONLY:  molecular_viscosity
     
        USE particle_attributes,                                                &
Index: /palm/trunk/SOURCE/lpm_droplet_collision.f90
===================================================================
--- /palm/trunk/SOURCE/lpm_droplet_collision.f90	(revision 3273)
+++ /palm/trunk/SOURCE/lpm_droplet_collision.f90	(revision 3274)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Modularization of all bulk cloud physics code components
+! 
+! 3241 2018-09-12 15:02:00Z raasch
 ! unused variables removed
 ! 
@@ -122,9 +125,6 @@
         ONLY:  diss, dzw, ql_v, ql_vp
 
-    USE cloud_parameters,                                                      &
-        ONLY:  rho_l, rho_s
-
-    USE constants,                                                             &
-        ONLY:  pi
+    USE basic_constants_and_equations_mod,                                     &
+        ONLY:  pi, rho_l, rho_s
 
     USE control_parameters,                                                    &
Index: /palm/trunk/SOURCE/lpm_droplet_condensation.f90
===================================================================
--- /palm/trunk/SOURCE/lpm_droplet_condensation.f90	(revision 3273)
+++ /palm/trunk/SOURCE/lpm_droplet_condensation.f90	(revision 3274)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Modularization of all bulk cloud physics code components
+! 
+! 3241 2018-09-12 15:02:00Z raasch
 ! unused variables removed
 ! 
@@ -136,12 +139,9 @@
 
     USE arrays_3d,                                                             &
-        ONLY:  dzw, hyp, pt, q, ql_c, ql_v
-
-    USE cloud_parameters,                                                      &
-        ONLY:  l_v, molecular_weight_of_solute,                        &
-               molecular_weight_of_water, rho_l, rho_s, r_v, vanthoff
-
-    USE constants,                                                             &
-        ONLY:  pi
+        ONLY:  dzw, hyp, pt, q, ql_c, ql_v, exner
+
+    USE basic_constants_and_equations_mod,                                     &
+        ONLY:  l_v, molecular_weight_of_solute, molecular_weight_of_water,     &
+               magnus, pi, rho_l, rho_s, r_v, vanthoff
 
     USE control_parameters,                                                    &
@@ -150,7 +150,4 @@
     USE cpulog,                                                                &
         ONLY:  cpu_log, log_point_s
-
-    USE diagnostic_quantities_mod,                                             &
-        ONLY:  magnus
 
     USE grid_variables,                                                        &
@@ -220,5 +217,5 @@
 !
 !-- Absolute temperature
-    t_int = pt(kp,jp,ip) * ( hyp(kp) / 100000.0_wp )**0.286_wp
+    t_int = pt(kp,jp,ip) * exner(kp)
 !
 !-- Saturation vapor pressure (Eq. 10 in Bolton, 1980)
Index: /palm/trunk/SOURCE/lpm_init.f90
===================================================================
--- /palm/trunk/SOURCE/lpm_init.f90	(revision 3273)
+++ /palm/trunk/SOURCE/lpm_init.f90	(revision 3274)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Modularization of all bulk cloud physics code components
+! 
+! 3241 2018-09-12 15:02:00Z raasch
 ! unused variables removed
 ! 
@@ -1051,16 +1054,9 @@
 
     USE arrays_3d,                                                             &
-        ONLY: hyp, pt, q
-
-    USE cloud_parameters,                                                      &
-        ONLY: molecular_weight_of_solute, molecular_weight_of_water, rho_l,    &
-              r_v, rho_s, vanthoff
-
-    USE constants,                                                             &
-        ONLY: pi
-
-    USE diagnostic_quantities_mod,                                             &
-        ONLY:  magnus
-
+        ONLY: hyp, pt, q, exner
+
+    USE basic_constants_and_equations_mod,                                     &
+        ONLY: molecular_weight_of_solute, molecular_weight_of_water, magnus,   &
+              pi, rho_l, r_v, rho_s, vanthoff
 
     USE kinds
@@ -1199,5 +1195,5 @@
 !--          the sometimes lengthy growth toward their equilibrium radius within
 !--          the simulation.
-             t_int  = pt(kp,jp,ip) * ( hyp(kp) / 100000.0_wp )**0.286_wp
+             t_int  = pt(kp,jp,ip) * exner(kp)
 
              e_s = magnus( t_int )
Index: /palm/trunk/SOURCE/lpm_splitting.f90
===================================================================
--- /palm/trunk/SOURCE/lpm_splitting.f90	(revision 3273)
+++ /palm/trunk/SOURCE/lpm_splitting.f90	(revision 3274)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Modularization of all bulk cloud physics code components
+! 
+! 3241 2018-09-12 15:02:00Z raasch
 ! unused variables removed
 ! 
@@ -61,9 +64,6 @@
         ONLY:  ql
 
-    USE cloud_parameters,                                                      &
-        ONLY:  rho_l
-
-    USE constants,                                                             &
-        ONLY:  pi
+    USE basic_constants_and_equations_mod,                                     &
+        ONLY:  pi, rho_l
 
     USE cpulog,                                                                &
Index: /palm/trunk/SOURCE/model_1d_mod.f90
===================================================================
--- /palm/trunk/SOURCE/model_1d_mod.f90	(revision 3273)
+++ /palm/trunk/SOURCE/model_1d_mod.f90	(revision 3274)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Modularization of all bulk cloud physics code components
+! 
+! 3135 2018-07-16 14:43:04Z gronemeier
 ! Bugfix: add +1 to c_3 according to Sogachev et al. (2012)
 ! 
@@ -173,9 +176,12 @@
         ONLY:  dd2zu, ddzu, ddzw, dzu, dzw, pt_init, q_init, ug, u_init,       &
                vg, v_init, zu
+
+    USE basic_constants_and_equations_mod,                                     &
+        ONLY:  g, kappa, pi
     
     USE control_parameters,                                                    &
-        ONLY:  constant_diffusion, constant_flux_layer, dissipation_1d, f, g,  &
+        ONLY:  constant_diffusion, constant_flux_layer, dissipation_1d, f,     &
                humidity, ibc_e_b, intermediate_timestep_count,                 &
-               intermediate_timestep_count_max, kappa, km_constant,            &
+               intermediate_timestep_count_max, km_constant,                   &
                message_string, mixing_length_1d, prandtl_number,               &
                roughness_length, run_description_header, simulated_time_chr,   &
@@ -989,7 +995,4 @@
 
 
-    USE constants,                                                             &
-        ONLY:  pi
-
     IMPLICIT NONE
 
Index: /palm/trunk/SOURCE/modules.f90
===================================================================
--- /palm/trunk/SOURCE/modules.f90	(revision 3273)
+++ /palm/trunk/SOURCE/modules.f90	(revision 3274)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Modularization of all bulk cloud physics code components
+! 
+! 3240 2018-09-12 12:04:40Z Giersch
 ! max_pr_user_tmp has been defined as a control variable because it is not 
 ! local anymore
@@ -985,4 +988,8 @@
     REAL(wp), DIMENSION(:), ALLOCATABLE ::  momentumflux_output_conversion  !< conversion factor array for momentumflux output
 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  hyrho   !< density of air calculated with hydrostatic pressure
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  exner   !< ratio of actual and potential temperature
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  d_exner !< ratio of potential and actual temperature
+
     SAVE
 
@@ -1044,59 +1051,4 @@
   
  END MODULE averaging
-
-
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Definition of variables and constants for cloud physics.
-!------------------------------------------------------------------------------!
- MODULE cloud_parameters
- 
-    USE kinds
-
-    REAL(wp) ::  cp = 1005.0_wp                            !< heat capacity of dry air (J kg-1 K-1)
-    REAL(wp) ::  l_v = 2.5E+06_wp                          !< latent heat of vaporization (J kg-1)
-    REAL(wp) ::  l_d_cp                                    !< l_v / cp
-    REAL(wp) ::  l_d_r                                     !< l_v / r_d
-    REAL(wp) ::  l_d_rv                                    !< l_v / r_v    
-    REAL(wp) ::  molecular_weight_of_solute = 0.05844_wp   !< mol. m. NaCl (kg mol-1)
-    REAL(wp) ::  molecular_weight_of_water = 0.01801528_wp !< mol. m. H2O (kg mol-1)
-    REAL(wp) ::  rho_l = 1.0E3_wp                          !< density of water (kg m-3)
-    REAL(wp) ::  rho_s = 2165.0_wp                         !< density of NaCl (kg m-3)
-    REAL(wp) ::  r_d = 287.0_wp                            !< sp. gas const. dry air (J kg-1 K-1)
-    REAL(wp) ::  r_v = 461.51_wp                           !< sp. gas const. water vapor (J kg-1 K-1)
-    REAL(wp) ::  vanthoff = 2.0_wp                         !< van't Hoff factor for NaCl
-
-
-
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  hyrho   !< density of air calculated with hydrostatic pressure 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  pt_d_t  !< ratio of potential and actual temperature
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  t_d_pt  !< ratio of actual and potential temperature
-
-    SAVE
-
- END MODULE cloud_parameters
-
-
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Definition of general constants.
-!------------------------------------------------------------------------------!
- MODULE constants
- 
-    USE kinds
-
-    REAL(wp) ::  pi = 3.141592654_wp  !< PI
-    REAL(wp) ::  adv_mom_1            !< 1/4 - constant used in 5th-order advection scheme for momentum advection (1st-order part)
-    REAL(wp) ::  adv_mom_3            !< 1/24 - constant used in 5th-order advection scheme for momentum advection (3rd-order part)
-    REAL(wp) ::  adv_mom_5            !< 1/120 - constant used in 5th-order advection scheme for momentum advection (5th-order part)
-    REAL(wp) ::  adv_sca_1            !< 1/2 - constant used in 5th-order advection scheme for scalar advection (1st-order part)
-    REAL(wp) ::  adv_sca_3            !< 1/12 - constant used in 5th-order advection scheme for scalar advection (3rd-order part)
-    REAL(wp) ::  adv_sca_5            !< 1/60 - constant used in 5th-order advection scheme for scalar advection (5th-order part)
-    
-    SAVE
-
- END MODULE constants
 
  
@@ -1157,6 +1109,4 @@
     CHARACTER (LEN=20)   ::  bc_uv_b = 'dirichlet'                        !< namelist parameter
     CHARACTER (LEN=20)   ::  bc_uv_t = 'dirichlet'                        !< namelist parameter
-    CHARACTER (LEN=20)   ::  aerosol_bulk = 'nacl'                        !< namelist parameter
-    CHARACTER (LEN=20)   ::  cloud_scheme = 'saturation_adjust'           !< namelist parameter
     CHARACTER (LEN=20)   ::  coupling_mode = 'uncoupled'                  !< coupling mode for atmosphere-ocean coupling  
     CHARACTER (LEN=20)   ::  coupling_mode_remote = 'uncoupled'           !< coupling mode of the remote process in case of coupled atmosphere-ocean runs
@@ -1311,7 +1261,4 @@
     INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  mask_k_global  !< global grid index of masked output point on z-dimension
 
-    LOGICAL ::  aerosol_nacl =.TRUE.                             !< nacl aerosol for bulk scheme
-    LOGICAL ::  aerosol_c3h4o4 =.FALSE.                          !< malonic acid aerosol for bulk scheme
-    LOGICAL ::  aerosol_nh4no3 =.FALSE.                          !< malonic acid aerosol for bulk scheme
     LOGICAL ::  agent_time_unlimited = .FALSE.                   !< namelist parameter
     LOGICAL ::  air_chemistry = .FALSE.                          !< chemistry model switch
@@ -1331,9 +1278,7 @@
     LOGICAL ::  bc_radiation_s = .FALSE.                         !< radiation boundary condition for outflow at south domain boundary
     LOGICAL ::  calc_soil_moisture_during_spinup = .FALSE.       !< namelist parameter
-    LOGICAL ::  call_microphysics_at_all_substeps = .FALSE.      !< namelist parameter
     LOGICAL ::  call_psolver_at_all_substeps = .TRUE.            !< namelist parameter
     LOGICAL ::  child_domain  = .FALSE.                          !< flag indicating that model is nested in a parent domain
     LOGICAL ::  cloud_droplets = .FALSE.                         !< namelist parameter
-    LOGICAL ::  cloud_physics = .FALSE.                          !< namelist parameter
     LOGICAL ::  cloud_top_radiation = .FALSE.                    !< namelist parameter
     LOGICAL ::  complex_terrain = .FALSE.                        !< namelist parameter
@@ -1375,8 +1320,4 @@
     LOGICAL ::  lsf_vert = .TRUE.                                !< use atmospheric forcing (large scale forcing)?
     LOGICAL ::  masking_method = .FALSE.                         !< namelist parameter
-    LOGICAL ::  microphysics_sat_adjust = .FALSE.                !< use saturation adjust bulk scheme?
-    LOGICAL ::  microphysics_kessler = .FALSE.                   !< use kessler bulk scheme?
-    LOGICAL ::  microphysics_morrison = .FALSE.                  !< use 2-moment Morrison (add. prog. eq. for nc and qc)
-    LOGICAL ::  microphysics_seifert = .FALSE.                   !< use 2-moment Seifert and Beheng scheme
     LOGICAL ::  mg_switch_to_pe0 = .FALSE.                       !< internal multigrid switch for steering the ghost point exchange in case that data has been collected on PE0
     LOGICAL ::  nesting_offline = .FALSE.                        !< flag controlling offline nesting in COSMO model  
@@ -1386,5 +1327,4 @@
     LOGICAL ::  passive_scalar = .FALSE.                         !< namelist parameter
     LOGICAL ::  plant_canopy = .FALSE.                           !< switch for use of plant canopy model
-    LOGICAL ::  precipitation = .FALSE.                          !< namelist parameter
     LOGICAL ::  random_heatflux = .FALSE.                        !< namelist parameter
     LOGICAL ::  rans_mode = .FALSE.                              !< switch between RANS and LES mode
@@ -1492,8 +1432,6 @@
     REAL(wp) ::  f = 0.0_wp                                    !< Coriolis parameter
     REAL(wp) ::  fs = 0.0_wp                                   !< Coriolis parameter
-    REAL(wp) ::  g = 9.81_wp                                   !< gravitational acceleration
     REAL(wp) ::  inflow_damping_height = 9999999.9_wp          !< namelist parameter
     REAL(wp) ::  inflow_damping_width = 9999999.9_wp           !< namelist parameter
-    REAL(wp) ::  kappa = 0.4_wp                                !< von Karman constant
     REAL(wp) ::  km_constant = -1.0_wp                         !< namelist parameter
     REAL(wp) ::  latitude = 55.0_wp                            !< namelist parameter
@@ -1512,5 +1450,4 @@
     REAL(wp) ::  particle_maximum_age = 9999999.9_wp           !< namelist parameter
     REAL(wp) ::  prandtl_number = 1.0_wp                       !< namelist parameter
-    REAL(wp) ::  precipitation_amount_interval = 9999999.9_wp  !< namelist parameter
     REAL(wp) ::  prho_reference                                !< reference state of potential density
     REAL(wp) ::  pt_damping_factor = 0.0_wp                    !< namelist parameter
Index: /palm/trunk/SOURCE/multi_agent_system_mod.f90
===================================================================
--- /palm/trunk/SOURCE/multi_agent_system_mod.f90	(revision 3273)
+++ /palm/trunk/SOURCE/multi_agent_system_mod.f90	(revision 3274)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Modularization of all bulk cloud physics code components
+! 
+! 3268 2018-09-21 13:45:37Z sward
 ! Cleaned up agent pointer assignment in output routine
 ! 
@@ -77,5 +80,5 @@
     USE, INTRINSIC ::  ISO_C_BINDING
 
-    USE constants,                                                             &
+    USE basic_constants_and_equations_mod,                                     &
         ONLY:  pi
 
@@ -2689,5 +2692,5 @@
 
        USE arrays_3d,                                                          &
-           ONLY:  u, v, pt, hyp
+           ONLY:  u, v, pt, hyp, exner
 
 !       USE chemistry_model_mod,                                                &
@@ -2761,6 +2764,5 @@
 !
 !--                Calculate temperature at agent position
-                   agents(nl)%t = pt(kl,jl,il) *                               &
-                                  ( hyp(kl) / 100000.0_wp )**0.286_wp
+                   agents(nl)%t = pt(kl,jl,il) * exner(kl)
 ! !
 ! !--                Get PM10 concentration at agent position, if possible
@@ -4107,7 +4109,4 @@
     SUBROUTINE mas_timestep_social_forces ( mode, nl, ip, jp )
 
-!       USE constants,                                                          &
-!           ONLY:  pi
-
        IMPLICIT NONE
 
Index: /palm/trunk/SOURCE/netcdf_interface_mod.f90
===================================================================
--- /palm/trunk/SOURCE/netcdf_interface_mod.f90	(revision 3273)
+++ /palm/trunk/SOURCE/netcdf_interface_mod.f90	(revision 3274)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Modularization of all bulk cloud physics code components
+! 
+! 3241 2018-09-12 15:02:00Z raasch
 ! unused variables removed
 ! 
@@ -552,5 +555,5 @@
         ONLY:  chem_define_netcdf_grid 
 
-    USE constants,                                                             &
+    USE basic_constants_and_equations_mod,                                     &
         ONLY:  pi
 
Index: /palm/trunk/SOURCE/palm.f90
===================================================================
--- /palm/trunk/SOURCE/palm.f90	(revision 3273)
+++ /palm/trunk/SOURCE/palm.f90	(revision 3274)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Modularization of all bulk cloud physics code components
+! 
+! 3258 2018-09-18 07:23:31Z Giersch
 ! current revision for user interface has been changed to 3240
 ! 
@@ -245,8 +248,8 @@
 
     USE control_parameters,                                                    &
-        ONLY:  air_chemistry, cloud_physics, constant_diffusion, child_domain, &
+        ONLY:  air_chemistry, constant_diffusion, child_domain,                &
                coupling_char, coupling_mode, do2d_at_begin, do3d_at_begin,     &
                humidity, initializing_actions, io_blocks, io_group,            &
-               message_string, microphysics_morrison, microphysics_seifert,    &
+               message_string,                                                 &
                neutral, passive_scalar, runnr, simulated_time_chr, spinup,     &
                time_since_reference_point, user_interface_current_revision,    &
@@ -259,4 +262,9 @@
         ONLY:  nbgp
 
+    USE kinds
+
+    USE bulk_cloud_model_mod,                                                  &
+        ONLY: bulk_cloud_model, microphysics_morrison, microphysics_seifert
+
     USE multi_agent_system_mod,                                                &
         ONLY:  agents_active, mas_last_actions
@@ -265,6 +273,4 @@
         ONLY:  netcdf_data_input_inquire_file, netcdf_data_input_init,         &
                netcdf_data_input_surface_data, netcdf_data_input_topo
-
-    USE kinds
 
     USE particle_attributes,                                                   &
@@ -442,9 +448,9 @@
              IF ( humidity )  THEN
                 CALL exchange_horiz( q, nbgp )
-                IF ( cloud_physics  .AND.  microphysics_morrison )  THEN
+                IF ( bulk_cloud_model  .AND.  microphysics_morrison )  THEN
                   CALL exchange_horiz( qc, nbgp )
                   CALL exchange_horiz( nc, nbgp )
                 ENDIF
-                IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
+                IF ( bulk_cloud_model  .AND.  microphysics_seifert )  THEN
                    CALL exchange_horiz( qr, nbgp ) 
                    CALL exchange_horiz( nr, nbgp )
